#include "DHT.h"

#define DHTPIN 2    //Para conectar el sensor de temperatura  

#define DHTTYPE DHT11  
  
DHT dht(DHTPIN, DHTTYPE);

// include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins
  LiquidCrystal lcd(12, 11,8, 7,5, 4); // pines de la lcd



//BOTOON
int buttonPin = 3; //pin conectado al boton
int buttonState = 0; //Contador donde se guarda si el estado del boton es 0 o 1 comenzando desde 0


//MANUAL Y AUTOMÁTICO
int PinRojo = 10; //Pin del RGB rojo
int PinAzul = 9; //Pin  del RGB azul
int PinVerde = 6; //Pin  del RGB verde

int potPin_rojo = A0;  //declarar pin  para el potencionetro de la led Roja
int potPin_verde = A1;  //declarar pin  para el potencionetro de la led verde
int potPin_azul = A2;  //declarar pin  para el potencionetro de la led Roja

int ValorColorRojo; //declarar variable para almacenar el valor leído del potenciómetro que controla el LED rojo
int ValorColorVerde; //declarar variable para almacenar el valor leído del potenciómetro que controla el LED verde
int ValorColorAzul; // declarar variable para almacenar el valor leído del potenciómetro que controla el LED azul

void setup() {

  
  pinMode(potPin_rojo, INPUT); // potenciómetro para LED rojo como entrada
  pinMode(potPin_verde, INPUT); // potenciómetro para LED verde como entrada
  pinMode(potPin_azul, INPUT); // potenciómetro para LED azul como entrada
  
  pinMode(PinRojo,OUTPUT); //Pin de led rojo salida
  pinMode(PinAzul,OUTPUT); //Pin de led azul salida
  pinMode(PinVerde, OUTPUT); //Pin de led verde salida

  pinMode(buttonPin, INPUT); // pin de el boton entrada
 //DHT11
  Serial.begin(9600);
  dht.begin();
  
  // numero de columnas y filas de la lcd
  lcd.begin(16, 2);
  
}

void manual(){
 

  lcd.clear();
  // Leer el voltaje en cada pin analógico, escale a 0-255 e invierta el valor para el ánodo común
  ValorColorRojo = (255 - map(analogRead(potPin_rojo), 0, 1024, 0, 255 ));
  ValorColorVerde = (255 - map(analogRead(potPin_verde), 0, 1024, 0, 255 ));
  ValorColorAzul = (255 - map(analogRead(potPin_azul), 0, 1024, 0, 255 ));
  lcd.print(ValorColorAzul); //Imprime la potencia del potenciometro que maneja el color del azul
  lcd.print(" ");
  lcd.print(ValorColorVerde);//Imprime la potencia del potenciometro que maneja el color del verde
  lcd.print(" ");
  lcd.print(ValorColorRojo);//Imprime la potencia del potenciometro que maneja el color del rojo
  
  analogWrite(PinRojo,ValorColorRojo); //escribir valor para cambiar el brillo del LED rojo
  analogWrite(PinVerde,ValorColorVerde); //escribir valor para cambiar el brillo del LED rojo
  analogWrite(PinAzul,ValorColorAzul); //escribir valor para cambiar el brillo del LED rojo
  delay(100);

} 



void automatico(){ //Funcion con temperatura y humedad
  delay (200); 
 
  float h = dht.readHumidity();
  // Lee la teemperatura en celcius Read temperature as Celsius (the default)
  float t = dht.readTemperature();
  // Lee la temperatura en fahrenheith
  
  // Verifica si todo se lee bien y pasa a lo siguinte si hay un error imprime error en la lectura
  if (isnan(h) || isnan(t) ) {
    Serial.println(F("ERROR EN LA LECTURA DEL SENSOR"));
    return;
  }

  if (h<70){ //si la temperatura es menor a 70 
       analogWrite(PinAzul, 80) ;
                 
  }else if (t<20) {
       analogWrite(PinRojo, 100) ;
            
  }else if (t>=20 && t<=25) {
       analogWrite(PinAzul, 100) ;
      
  }
  if (h>=71 && h<=80){
      analogWrite(PinRojo, 155) ;

  } else if (t<20) {
      analogWrite(PinAzul, 30) ;
      analogWrite(PinVerde, 20);
      
  }else if (t>=20 && t<=25) {
      analogWrite(PinAzul, 10) ;
      analogWrite(PinVerde,30 );
      
  }else if (t>25) {
      analogWrite(PinAzul, 15) ;
      analogWrite(PinVerde, 200);
  }
      
  if (h>=81 && h<=90) {
      analogWrite(PinAzul, 155) ;
      
      } else if (t<20) {
      analogWrite(PinRojo, 20) ;  
      analogWrite(PinVerde, 50);
      
     }else if (t>=20 && t<=25) {
      analogWrite(PinRojo, 40) ;
      analogWrite(PinVerde, 20);
      
     }else if (t>25) {
      analogWrite(PinRojo, 50) ;
      analogWrite(PinVerde, 10);
      }
  
   if (h>90 ){
      analogWrite(PinVerde, 155);
 
   } else if (t<20) {
       analogWrite(PinRojo, 50) ;
      analogWrite(PinAzul, 20) ;
      
    }else if (t>=20 && t<=25) {
      analogWrite(PinRojo, 20) ;
      analogWrite(PinAzul, 30) ;
     
   }else if (t>25) {
       analogWrite(PinRojo, 20) ;
      analogWrite(PinAzul, 50) ;
   }
   
  Serial.print(F("Humedad "));
  Serial.print(h);
  Serial.print(F("%  Temperatura: "));
  Serial.print(t);
  Serial.println(F("°C "));
  delay(1000);
  
  lcd.setCursor(0,0);//Dice que lo imprima en la fila  caracter 
  //Imprime la humedad y la temperatura en el LCD
  lcd.print("Hum " + String (h)+" Celcius"); 
  lcd.setCursor(0,1);
  lcd.print("temp " + String(t) + " Fahrenheit");

  
  
}







void loop(){
int Boton = digitalRead(buttonPin);

if (Boton == HIGH){ //Si el boton está en alto hacer... El boton al inicio está en alto.
     //si está en modo manual
  if (buttonState == 0){    //Cambia el estado del boton a 1 que es el modo automatico.
     buttonState = 1;
     
  }
  else if (buttonState == 1){ //si el estado del boton es 1, el estado del boton cambia a 0 el modo sera manual.
    buttonState = 0;
    
  }

}
while (digitalRead(buttonPin)==HIGH); //Mantener el codigo funcionando mientras hayan rebotes

if (buttonState == 0){ // si el estado del boton es 0 el modo que se ejecutara sera el manual.
    manual();
    
  
} else if (buttonState == 1) { //Si el estado del boton es 1 el modo que se corre es el automatico.
    automatico();
    
  }

}
